import { QueryBatch } from './query_batch';
import { QueryDelete } from './query_delete';
import { QueryInsert } from './query_insert';
import { QuerySelect } from './query_select';
import { QueryUpdate } from './query_update';
import { WhereFilter } from './where_filter';
export declare class Client {
    protected readonly queryFn: any;
    constructor(queryFn: any);
    select<T>(...columns: string[]): QuerySelect<T>;
    count(column?: string): QuerySelect<number>;
    insert(values: Array<{}>): QueryInsert;
    delete(filter: WhereFilter): QueryDelete;
    update(table: string): QueryUpdate;
    batch(table: string): QueryBatch;
    query(options: string, values?: any): Promise<any>;
}
