"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Entity {
    constructor(row) {
        if (row) {
            const { columns = [] } = this.constructor;
            columns.forEach(([columnName, propertyName]) => {
                const value = row[columnName];
                if (value !== undefined) {
                    this[propertyName] = value;
                }
            });
        }
    }
    merge(...args) {
        const { columns = [] } = this.constructor;
        args.forEach(values => {
            columns.forEach(([columnName, propertyName]) => {
                const value = values[propertyName];
                if (value !== undefined) {
                    this[propertyName] = value;
                }
            });
        });
    }
    toRow() {
        const { columns = [] } = this.constructor;
        const row = {};
        columns.forEach(([columnName, propertyName]) => {
            const value = this[propertyName];
            if (value !== undefined) {
                row[columnName] = this[propertyName];
            }
        });
        return row;
    }
}
exports.Entity = Entity;
function Column(name) {
    return (target, propertyName) => {
        const { constructor } = target;
        const columns = constructor.columns || [];
        columns.push([name, propertyName]);
        constructor.columns = columns;
    };
}
exports.Column = Column;
//# sourceMappingURL=entity.js.map