"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mysql = require("mysql");
const client_1 = require("./client");
const transaction_1 = require("./transaction");
exports.escape = mysql.escape;
exports.escapeId = mysql.escapeId;
class Bsql extends client_1.Client {
    constructor(pool) {
        super((...args) => pool.query.apply(pool, args));
        this.pool = pool;
    }
    beginTransaction() {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                this.pool.getConnection((err, connection) => {
                    if (err) {
                        reject(err);
                    }
                    else {
                        connection.beginTransaction((e) => {
                            if (e) {
                                reject(e);
                            }
                            else {
                                resolve(new transaction_1.Transaction(connection));
                            }
                        });
                    }
                });
            });
        });
    }
}
exports.Bsql = Bsql;
function bsql(config) {
    const db = mysql.createPool(config);
    return new Bsql(db);
}
exports.default = bsql;
//# sourceMappingURL=index.js.map