"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Query {
    constructor(query) {
        this.query = query;
        this[Symbol.toStringTag] = 'Promise';
        this.sql = {};
        this.plugins = [];
        let resolve;
        let reject;
        const promise = new Promise((s, j) => {
            resolve = s;
            reject = j;
        });
        const that = this;
        this.promise = promise;
        return new Proxy(promise, {
            get(target, name) {
                if (name === 'then' || name === 'catch') {
                    that.execute(resolve, reject);
                    return target[name].bind(target);
                }
                else {
                    return name in that ? that[name] : target[name];
                }
            },
        });
    }
    get then() {
        return this.promise.then;
    }
    get catch() {
        return this.promise.catch;
    }
    plugin(cb) {
        this.plugins.push(cb);
    }
    execute(resolve, reject) {
        this.query(this.getSql().filter((x) => !!x).join(' ') + ';', (err, results) => {
            if (err) {
                reject(err);
            }
            else {
                resolve(this.plugins.reduce((pre, cur) => cur(pre), results));
            }
        });
    }
}
exports.Query = Query;
//# sourceMappingURL=query.js.map