"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mysql_1 = require("mysql");
const bsql_error_1 = require("./bsql_error");
const query_1 = require("./query");
const transform_1 = require("./transform");
const where_filter_1 = require("./where_filter");
class QueryUpdate extends query_1.Query {
    update(table) {
        this.sql.update = `UPDATE ${mysql_1.escapeId(table)}`;
        return this;
    }
    set(value) {
        this.sql.set = `SET ${mysql_1.escape(transform_1.snakeCase(value))}`;
        return this;
    }
    where(filter) {
        this.sql.where = `WHERE ${where_filter_1.buildWhereSql(filter)}`;
        return this;
    }
    getSql() {
        bsql_error_1.assert(this.sql.set, 'Value is required, please call set(value).');
        bsql_error_1.assert(this.sql.where, 'Filter is required, please call where(filter).');
        return [this.sql.update, this.sql.set, this.sql.where];
    }
}
exports.QueryUpdate = QueryUpdate;
//# sourceMappingURL=query_update.js.map