"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const client_1 = require("./client");
class Transaction extends client_1.Client {
    constructor(connection) {
        super((...args) => connection.query.apply(connection, args));
        this.connection = connection;
    }
    commit() {
        return new Promise((resolve, reject) => {
            this.connection.commit((err) => {
                this.connection.release();
                err ? reject(err) : resolve();
            });
        });
    }
    rollback() {
        return new Promise((resolve) => {
            this.connection.rollback((err) => {
                this.connection.release();
                resolve();
            });
        });
    }
}
exports.Transaction = Transaction;
//# sourceMappingURL=transaction.js.map